commit 859b92a50e7971393a845672a546a85c6284477a
Author: freddy77 <freddy77>
Date:   Fri Jan 29 18:57:03 2010 +0000

    complete connection string if possible

diff --git a/ChangeLog b/ChangeLog
index 600d0b4..5c5547c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Fri Jan 29 19:56:51 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h include/tdsodbc.h src/odbc/connectparams.c:
+	* src/odbc/odbc.c src/tds/config.c win32/winsetup.c:
+	- complete connection string if possible
+
 Fri Jan 29 15:08:07 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* win32/setup.rc: make popup window always visible
 
@@ -2261,4 +2266,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2975 2010/01/29 14:08:56 freddy77 Exp $
+$Id: ChangeLog,v 1.2976 2010/01/29 18:57:03 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index c2ec04b..63f151d 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -21,7 +21,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.330 2010/01/29 14:04:59 freddy77 Exp $ */
+/* $Id: tds.h,v 1.331 2010/01/29 18:57:03 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1417,6 +1417,7 @@ TDS_USMALLINT tds_config_verstr(const char *tdsver, TDSCONNECTION * connection);
 int tds_lookup_host(const char *servername, char *ip);
 int tds_set_interfaces_file_loc(const char *interfloc);
 extern const char STD_DATETIME_FMT[];
+int tds_config_boolean(const char *value);
 
 TDSLOCALE *tds_get_locale(void);
 int tds_alloc_row(TDSRESULTINFO * res_info);
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index f72cfe9..afd1c65 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -1,6 +1,6 @@
 /* FreeTDS - Library of routines accessing Sybase and Microsoft databases
  * Copyright (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005  Brian Bruns
- * Copyright (C) 2004, 2005, 2006, 2007, 2008  Frediano Ziglio
+ * Copyright (C) 2004-2010  Frediano Ziglio
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Library General Public
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.118 2010/01/25 23:05:59 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.119 2010/01/29 18:57:03 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4 && !defined(__MINGW32__)
 #pragma GCC visibility push(hidden)
@@ -434,9 +434,45 @@ typedef struct _hchk TDS_CHK;
 BOOL get_login_info(HWND hwndParent, TDSCONNECTION * connection);
 #endif
 
+#define ODBC_PARAM_LIST \
+	ODBC_PARAM(Servername) \
+	ODBC_PARAM(Server) \
+	ODBC_PARAM(DSN) \
+	ODBC_PARAM(UID) \
+	ODBC_PARAM(PWD) \
+	ODBC_PARAM(Address) \
+	ODBC_PARAM(Port) \
+	ODBC_PARAM(TDS_Version) \
+	ODBC_PARAM(Language) \
+	ODBC_PARAM(Database) \
+	ODBC_PARAM(TextSize) \
+	ODBC_PARAM(PacketSize) \
+	ODBC_PARAM(ClientCharset) \
+	ODBC_PARAM(DumpFile) \
+	ODBC_PARAM(DumpFileAppend) \
+	ODBC_PARAM(DebugFlags) \
+	ODBC_PARAM(Encryption) \
+	ODBC_PARAM(Trusted_Connection) \
+	ODBC_PARAM(APP) \
+	ODBC_PARAM(WSID)
+
+#define ODBC_PARAM(p) ODBC_PARAM_##p,
+enum {
+	ODBC_PARAM_LIST
+	ODBC_PARAM_SIZE
+};
+#undef ODBC_PARAM
+
+
 /*
  * connectparams.h
  */
+
+typedef struct {
+	const char *p;
+	size_t len;
+} TDS_PARSED_PARAM;
+
 /**
  * Parses a connection string for SQLDriverConnect().
  * \param connect_string      point to connection string
@@ -444,8 +480,11 @@ BOOL get_login_info(HWND hwndParent, TDSCONNECTION * connection);
  * \param connection          structure where to store informations
  * \return 0 if error, 1 otherwise
  */
-int odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection);
+int odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection, TDS_PARSED_PARAM *parsed_params);
 int odbc_get_dsn_info(TDS_ERRS *errs, const char *DSN, TDSCONNECTION * connection);
+#ifdef _WIN32
+int odbc_build_connect_string(TDS_ERRS *errs, TDS_PARSED_PARAM *params, char **out);
+#endif
 
 /*
  * convert_tds2sql.c
diff --git a/src/odbc/connectparams.c b/src/odbc/connectparams.c
index 62d9119..9f076db 100644
--- a/src/odbc/connectparams.c
+++ b/src/odbc/connectparams.c
@@ -37,22 +37,17 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: connectparams.c,v 1.84 2010/01/28 08:54:35 freddy77 Exp $");
-
-static const char odbc_param_Servername[] = "Servername";
-static const char odbc_param_Address[] = "Address";
-static const char odbc_param_Server[] = "Server";
-static const char odbc_param_Port[] = "Port";
-static const char odbc_param_TDS_Version[] = "TDS_Version";
-static const char odbc_param_Language[] = "Language";
-static const char odbc_param_Database[] = "Database";
-static const char odbc_param_TextSize[] = "TextSize";
-static const char odbc_param_PacketSize[] = "PacketSize";
-static const char odbc_param_ClientCharset[] = "ClientCharset";
-static const char odbc_param_DumpFile[] = "DumpFile";
-static const char odbc_param_DumpFileAppend[] = "DumpFileAppend";
-static const char odbc_param_DebugFlags[] = "DebugFlags";
-static const char odbc_param_Encryption[] = "Encryption";
+TDS_RCSID(var, "$Id: connectparams.c,v 1.85 2010/01/29 18:57:03 freddy77 Exp $");
+
+#define ODBC_PARAM(p) static const char odbc_param_##p[] = #p;
+ODBC_PARAM_LIST
+#undef ODBC_PARAM
+
+#define ODBC_PARAM(p) odbc_param_##p,
+static const char *odbc_param_names[] = {
+	ODBC_PARAM_LIST
+};
+#undef ODBC_PARAM
 
 #if !HAVE_SQLGETPRIVATEPROFILESTRING
 
@@ -233,16 +228,23 @@ odbc_get_dsn_info(TDS_ERRS *errs, const char *DSN, TDSCONNECTION * connection)
  * @return 1 if success 0 otherwhise
  */
 int
-odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection)
+odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char *connect_string_end, TDSCONNECTION * connection,
+			  TDS_PARSED_PARAM *parsed_params)
 {
 	const char *p, *end;
 	DSTR *dest_s, value;
 	enum { CFG_DSN = 1, CFG_SERVER = 2, CFG_SERVERNAME = 4 };
 	unsigned int cfgs = 0;	/* flags for indicate second parse of string */
-	char option[16];
+	char option[24];
+	int trusted = 0;
+
+	if (parsed_params)
+		memset(parsed_params, 0, sizeof(*parsed_params)*ODBC_PARAM_SIZE);
 
 	tds_dstr_init(&value);
 	for (p = connect_string; p < connect_string_end && *p;) {
+		int num_param = -1;
+
 		dest_s = NULL;
 
 		/* handle empty options */
@@ -287,7 +289,8 @@ odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char
 			return 0;
 		}
 
-		if (strcasecmp(option, odbc_param_Server) == 0) {
+#define CHK_PARAM(p) (strcasecmp(option, odbc_param_##p) == 0 && (num_param=ODBC_PARAM_##p) >= 0)
+		if (CHK_PARAM(Server)) {
 			/* error if servername or DSN specified */
 			if ((cfgs & (CFG_DSN|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
@@ -303,7 +306,7 @@ odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char
 				}
 				cfgs = CFG_SERVER;
 			}
-		} else if (strcasecmp(option, odbc_param_Servername) == 0) {
+		} else if (CHK_PARAM(Servername)) {
 			if ((cfgs & (CFG_DSN|CFG_SERVER)) != 0) {
 				tds_dstr_free(&value);
 				odbc_errs_add(errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
@@ -316,7 +319,7 @@ odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char
 				p = connect_string;
 				continue;
 			}
-		} else if (strcasecmp(option, "DSN") == 0) {
+		} else if (CHK_PARAM(DSN)) {
 			if ((cfgs & (CFG_SERVER|CFG_SERVERNAME)) != 0) {
 				tds_dstr_free(&value);
 				odbc_errs_add(errs, "HY000", "Only one between SERVER, SERVERNAME and DSN can be specified");
@@ -331,39 +334,48 @@ odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char
 				p = connect_string;
 				continue;
 			}
-		} else if (strcasecmp(option, odbc_param_Database) == 0) {
+		} else if (CHK_PARAM(Database)) {
 			dest_s = &connection->database;
-		} else if (strcasecmp(option, "UID") == 0) {
+		} else if (CHK_PARAM(UID)) {
 			dest_s = &connection->user_name;
-		} else if (strcasecmp(option, "PWD") == 0) {
+		} else if (CHK_PARAM(PWD)) {
 			dest_s = &connection->password;
-		} else if (strcasecmp(option, "APP") == 0) {
+		} else if (CHK_PARAM(APP)) {
 			dest_s = &connection->app_name;
-		} else if (strcasecmp(option, "WSID") == 0) {
+		} else if (CHK_PARAM(WSID)) {
 			dest_s = &connection->client_host_name;
-		} else if (strcasecmp(option, odbc_param_Language) == 0) {
+		} else if (CHK_PARAM(Language)) {
 			tds_parse_conf_section(TDS_STR_LANGUAGE, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_Port) == 0) {
+		} else if (CHK_PARAM(Port)) {
 			tds_parse_conf_section(TDS_STR_PORT, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_TDS_Version) == 0) {
+		} else if (CHK_PARAM(TDS_Version)) {
 			tds_parse_conf_section(TDS_STR_VERSION, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_TextSize) == 0) {
+		} else if (CHK_PARAM(TextSize)) {
 			tds_parse_conf_section(TDS_STR_TEXTSZ, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_PacketSize) == 0) {
+		} else if (CHK_PARAM(PacketSize)) {
 			tds_parse_conf_section(TDS_STR_BLKSZ, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_ClientCharset) == 0) {
+		} else if (CHK_PARAM(ClientCharset)) {
 			tds_parse_conf_section(TDS_STR_CLCHARSET, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_DumpFile) == 0) {
+		} else if (CHK_PARAM(DumpFile)) {
 			tds_parse_conf_section(TDS_STR_DUMPFILE, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_DumpFileAppend) == 0) {
+		} else if (CHK_PARAM(DumpFileAppend)) {
 			tds_parse_conf_section(TDS_STR_APPENDMODE, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_DebugFlags) == 0) {
+		} else if (CHK_PARAM(DebugFlags)) {
 			tds_parse_conf_section(TDS_STR_DEBUGFLAGS, tds_dstr_cstr(&value), connection);
-		} else if (strcasecmp(option, odbc_param_Encryption) == 0) {
+		} else if (CHK_PARAM(Encryption)) {
 			tds_parse_conf_section(TDS_STR_ENCRYPTION, tds_dstr_cstr(&value), connection);
+		} else if (CHK_PARAM(Trusted_Connection)) {
+			trusted = tds_config_boolean(tds_dstr_cstr(&value));
+			tdsdump_log(TDS_DBG_INFO1, "trusted %s -> %d\n", tds_dstr_cstr(&value), trusted);
+			num_param = -1;
 			/* TODO odbc_param_Address field */
 		}
 
+		if (num_param >= 0 && parsed_params) {
+			parsed_params[num_param].p = p;
+			parsed_params[num_param].len = end - p;
+		}
+
 		/* copy to destination */
 		if (dest_s) {
 			DSTR tmp = *dest_s;
@@ -380,10 +392,53 @@ odbc_parse_connect_string(TDS_ERRS *errs, const char *connect_string, const char
 		++p;
 	}
 
+	if (trusted) {
+		if (parsed_params) {
+			parsed_params[ODBC_PARAM_Trusted_Connection].p = "Yes";
+			parsed_params[ODBC_PARAM_Trusted_Connection].len = 3;
+			parsed_params[ODBC_PARAM_UID].p = NULL;
+			parsed_params[ODBC_PARAM_PWD].p = NULL;
+		}
+		tds_dstr_copy(&connection->user_name, "");
+		tds_dstr_copy(&connection->password, "");
+	}
+
 	tds_dstr_free(&value);
 	return 1;
 }
 
+#ifdef _WIN32
+int
+odbc_build_connect_string(TDS_ERRS *errs, TDS_PARSED_PARAM *params, char **out)
+{
+	unsigned n;
+	size_t len = 1;
+	char *p;
+
+	/* compute string size */
+	for (n = 0; n < ODBC_PARAM_SIZE; ++n) {
+		if (params[n].p)
+			len += strlen(odbc_param_names[n]) + params[n].len + 2;
+	}
+
+	/* allocate */
+	p = (char*) malloc(len);
+	if (!p) {
+		odbc_errs_add(errs, "HY001", NULL);
+		return 0;
+	}
+	*out = p;
+
+	/* build it */
+	for (n = 0; n < ODBC_PARAM_SIZE; ++n) {
+		if (params[n].p)
+			p += sprintf(p, "%s=%.*s;", odbc_param_names[n], (int) params[n].len, params[n].p);
+	}
+	*p = 0;
+	return 1;
+}
+#endif
+
 #if !HAVE_SQLGETPRIVATEPROFILESTRING
 
 #ifdef _WIN32
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index efe7c8a..eba4f63 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.527 2010/01/27 08:31:26 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.528 2010/01/29 18:57:03 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -411,6 +411,7 @@ SQLDriverConnect(SQLHDBC hdbc, SQLHWND hwnd, SQLCHAR FAR * szConnStrIn, SQLSMALL
 {
 	TDSCONNECTION *connection;
 	int conlen = odbc_get_string_size(cbConnStrIn, szConnStrIn);
+	TDS_PARSED_PARAM params[ODBC_PARAM_SIZE];
 
 	INIT_HDBC;
 
@@ -447,27 +448,49 @@ SQLDriverConnect(SQLHDBC hdbc, SQLHWND hwnd, SQLCHAR FAR * szConnStrIn, SQLSMALL
 		tds_dstr_dup(&connection->database, &dbc->attr.current_catalog);
 
 	/* parse the DSN string */
-	odbc_parse_connect_string(&dbc->errs, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen, connection);
+	if (!odbc_parse_connect_string(&dbc->errs, (const char *) szConnStrIn, (const char *) szConnStrIn + conlen,
+				       connection, params))
+		ODBC_RETURN(dbc, SQL_ERROR);
+
+	odbc_set_string(szConnStrOut, cbConnStrOutMax, pcbConnStrOut, (const char *) szConnStrIn, conlen);
 
 	/* add login info */
-	if (hwnd) {
+	if (hwnd && fDriverCompletion != SQL_DRIVER_NOPROMPT
+	    && (fDriverCompletion == SQL_DRIVER_PROMPT || (!params[ODBC_PARAM_UID].p && !params[ODBC_PARAM_Trusted_Connection].p)
+		|| tds_dstr_isempty(&connection->server_name))) {
 #ifdef _WIN32
+		char *out = NULL;
+
 		/* prompt for login information */
 		if (!get_login_info(hwnd, connection)) {
 			tds_free_connection(connection);
 			odbc_errs_add(&dbc->errs, "08001", "User canceled login");
 			ODBC_RETURN(dbc, SQL_ERROR);
 		}
+		if (tds_dstr_isempty(&connection->user_name)) {
+			params[ODBC_PARAM_UID].p = NULL;
+			params[ODBC_PARAM_PWD].p = NULL;
+			params[ODBC_PARAM_Trusted_Connection].p = "Yes";
+			params[ODBC_PARAM_Trusted_Connection].len = 3;
+		} else {
+			params[ODBC_PARAM_UID].p   = tds_dstr_cstr(&connection->user_name);
+			params[ODBC_PARAM_UID].len = tds_dstr_len(&connection->user_name);
+			params[ODBC_PARAM_PWD].p   = tds_dstr_cstr(&connection->password);
+			params[ODBC_PARAM_PWD].len = tds_dstr_len(&connection->password);
+			params[ODBC_PARAM_Trusted_Connection].p = NULL;
+		}
+		if (!odbc_build_connect_string(&dbc->errs, params, &out))
+			ODBC_RETURN(dbc, SQL_ERROR);
+
+		odbc_set_string(szConnStrOut, cbConnStrOutMax, pcbConnStrOut, out, -1);
+		tdsdump_log(TDS_DBG_INFO1, "connection string is now: %s\n", out);
+		free(out);
 #else
 		/* we dont support a dialog box */
 		odbc_errs_add(&dbc->errs, "HYC00", NULL);
 #endif
 	}
 
-	/* TODO what should be correct behavior for output string?? -- freddy77 */
-	if (szConnStrOut)
-		odbc_set_string(szConnStrOut, cbConnStrOutMax, pcbConnStrOut, (const char *) szConnStrIn, conlen);
-
 	if (tds_dstr_isempty(&connection->server_name)) {
 		tds_free_connection(connection);
 		odbc_errs_add(&dbc->errs, "IM007", "Could not find Servername or server parameter");
@@ -3800,7 +3823,7 @@ SQLFetchScroll(SQLHSTMT hstmt, SQLSMALLINT FetchOrientation, SQLLEN FetchOffset)
 SQLRETURN ODBC_API
 SQLFreeHandle(SQLSMALLINT HandleType, SQLHANDLE Handle)
 {
-	tdsdump_log(TDS_DBG_INFO1, "SQLFreeHandle(%d, 0x%p)\n", HandleType, (void *) Handle);
+	tdsdump_log(TDS_DBG_INFO1, "SQLFreeHandle(%d, %p)\n", HandleType, (void *) Handle);
 
 	switch (HandleType) {
 	case SQL_HANDLE_STMT:
diff --git a/src/tds/config.c b/src/tds/config.c
index 19979fe..96cbd9c 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.156 2010/01/27 12:16:09 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.157 2010/01/29 18:57:03 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -85,7 +85,6 @@ static void tds_config_env_tdsport(TDSCONNECTION * connection);
 static void tds_config_env_tdshost(TDSCONNECTION * connection);
 static int tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection);
 static int tds_read_interfaces(const char *server, TDSCONNECTION * connection);
-static int tds_config_boolean(const char *value);
 static int parse_server_name_for_port(TDSCONNECTION * connection, TDSLOGIN * login);
 static int tds_lookup_port(const char *portname);
 static void tds_config_encryption(const char * value, TDSCONNECTION * connection);
@@ -396,7 +395,7 @@ static const struct {
 	{ "false",	0 }
 };
 
-static int
+int
 tds_config_boolean(const char *value)
 {
 	int p;
diff --git a/win32/winsetup.c b/win32/winsetup.c
index a0809e4..ac8ec3b 100644
--- a/win32/winsetup.c
+++ b/win32/winsetup.c
@@ -135,7 +135,7 @@ parse_wacky_dsn_string(LPCSTR attribs, DSNINFO * di)
 	}
 
 	/* let odbc_parse_connect_string() parse the ;-delimited version */
-	odbc_parse_connect_string(NULL, build, build + strlen(build), di->connection);
+	odbc_parse_connect_string(NULL, build, build + strlen(build), di->connection, NULL);
 }
 
 

